#include <glib.h>
#include <stdlib.h>

void goption_show_error(GOptionContext *context)
{   
    gchar *options_help;
    options_help = g_option_context_get_help (context, TRUE, NULL);
    g_print("%s", options_help);
    g_free(options_help);
}   

void goption_error_func(GOptionContext *context, GOptionGroup *group, gpointer data, GError **error)
{
    if (*error && (*error)->message) {
        gchar *progname = g_get_prgname();
        g_print("%s: %s\nTry '%s --help' for more information.\n", progname, (*error)->message, progname);
        goption_show_error(context);
        exit(1);
    }
}

