#include <glib.h>
#include <glib/gi18n.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "libbox-db.h"
#include "libbox-db-utils.h"
#include "libbox-db-deps.h"
#include "libbox-db-repos.h"
#include "libbox-parser.h"
#include "libbox-repos.h"

#include <glib.h>
#include <glib/gi18n.h>
#include <stdio.h>
#include <string.h>

#include "libbox-db.h"
#include "libbox-db-deps.h"
#include "libbox-db-utils.h"
#include "libbox-parser.h"
#include "libinternal-utils.h"


static gchar* dest_dir = "/";


static GOptionEntry entries[] =
{
    { "root", 0, 0, G_OPTION_ARG_STRING, &dest_dir, "Specify installation directory (default is '/')", "PATH" },
    { NULL }
};


int main (int argc, char *argv[])
{
    DepsResolve *deps;
    GList *li;
    sqlite3 *db;
    GError *error = NULL;
    GOptionContext *context;

    context = g_option_context_new ("box-repos");
    g_option_context_add_main_entries (context, entries, NULL);
    g_option_context_set_help_enabled(context, TRUE);
    g_option_group_set_error_hook(g_option_context_get_main_group(context), (GOptionErrorFunc)goption_error_func);
    g_option_context_parse (context, &argc, &argv, &error);

    db = box_db_open(dest_dir);

    box_db_attach_repos(db, box_get_repos_dir(dest_dir));
    box_db_repos_init(db);


    if (argc == 2)
    {
        deps = box_db_repos_resolve_deps_recurse(db, argv[1], FALSE);
        /*deps = box_db_repos_resolve_deps_one(db, argv[1]); */

        if (deps->deps)
            printf("Dependencies:\n");

        for (li = deps->deps; li != NULL; li = li->next)
        {
            printf("- %s\n", (gchar*)li->data);
        }

        if (deps->missing)
            printf("Missing:\n");

        for (li = deps->missing; li != NULL; li = li->next)
        {
            printf("- %s\n", (gchar*)li->data);
        }
    }

    g_option_context_free(context);
    box_db_close(db);

    return 0;
}
