#ifndef _DB_DEPS_H_
#define _DB_DEPS_H_

#include <glib.h>
#include <sqlite3.h>
#include <libbox-db-repos.h>

#define DEPS_REQUIRE 0
#define DEPS_PROVIDE 1
#define DEPS_NORMAL 0
#define DEPS_BUILD 1

typedef struct {
    gchar *name;
    gchar *state;
    gchar *package;
} DependencyInfo;

void box_db_install_requires(sqlite3 *db, gint package_id, const gchar *filename);
void box_db_install_build_requires(sqlite3 *db, gint package_id, const gchar *filename);
void box_db_install_provides(sqlite3 *db, gint package_id, const gchar *filename);
void box_db_install_build_provides(sqlite3 *db, gint package_id, const gchar *filename);

GList* box_db_check_deps_upgrade(sqlite3 *db, const gchar *filename, const gchar *name);

void box_db_deps_free(DependencyInfo *dep_info);
void box_db_deps_list_free(GList *list);

GList* box_db_remove_deps(sqlite3 *db, const gchar *package, gboolean force);

GList* box_db_deps_get_requires(sqlite3 *db, const gchar *package);
GList* box_db_deps_get_build_requires(sqlite3 *db, const gchar *package);
GList* box_db_deps_get_provides(sqlite3 *db, const gchar *package);
GList* box_db_deps_get_build_provides(sqlite3 *db, const gchar *package);

#endif
