#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>
#include <glib.h>

#include "libbox-download.h"

size_t my_write_func(void *ptr, size_t size, size_t nmemb, FILE *stream)
{
    return fwrite(ptr, size, nmemb, stream);
}

size_t my_read_func(void *ptr, size_t size, size_t nmemb, FILE *stream)
{
    return fread(ptr, size, nmemb, stream);
}


gboolean box_download_file(gchar *from, gchar *to)
{
    CURL *curl;
    CURLcode res;
    FILE *outfile;

    curl = curl_easy_init();
    if (curl)
    {
        outfile = fopen(to, "w");

        if (outfile == NULL)
            return FALSE;

        curl_easy_setopt(curl, CURLOPT_URL, from);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, outfile);
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, my_write_func);
        curl_easy_setopt(curl, CURLOPT_READFUNCTION, my_read_func);
        curl_easy_setopt(curl, CURLOPT_NOPROGRESS, TRUE);

        /* TODO: check somehow HTTP 200 */
        res = curl_easy_perform(curl);

        fclose(outfile);

        curl_easy_cleanup(curl);

        /* TODO: display error in case of failure */
        return (res == CURLE_OK);
    }

    return FALSE;
}

