#ifndef _REPOS_H_
#define _REPOS_H_

#include <glib.h>
#include "libbox.h"

typedef struct {
    gchar *name;
    gchar *description;
    gchar *url;
    gboolean enabled;
} RepoInfo;

RepoInfo* box_repos_repo_new(const gchar *name, const gchar *description, const gchar *url, gboolean enabled);
void box_repos_repo_free(RepoInfo *repo);

GList* box_repos_list_get();

void box_repos_list_free(GList *list);
gboolean box_repos_enable_repo(const gchar *name, gboolean enable);
gboolean box_repos_set_param(const gchar *group, const gchar *key, const gchar *value);
void box_repos_sync(const gchar *dest_dir, progressFunc, gpointer user_data);

#endif
